import 'package:flutter_mylibrary/base/request_info.dart';
import 'package:flutter_mylibrary/http/exception/http_error.dart';
import 'package:flutter_mylibrary/http/http_data.dart';
import 'package:flutter_mylibrary/utils/utils.dart';
import 'base_request_helper.dart';

mixin BaseController implements BaseRequestHelper{

  ///获取请求的数据，一般用于简单的页面请求
  RequestInfo getRequestInfo();

  RequestInfo beforeRequest(RequestInfo requestInfo){
    return requestInfo;
  }

  RequestInfo requestInfo;



  ///---------------------------------------------通用请求方法------------------------------------------------------

  ///通常有下拉刷新请求，第一页之后不会再设置页面错误状态
  Future<HttpData> request(void handleHttpData(HttpData data), {bool isSetError = true}) async{

    requestInfo = beforeRequest(requestInfo??getRequestInfo());


    HttpData _httpData = await doRequest(requestInfo);

    if(isEmpty(_httpData.httpError)){
      try{
        handleHttpData(_httpData);
      }catch(e){
        HttpError httpError = getParseDataError(e);
        if(isSetError){
          setError(httpError);
        }
        _httpData.httpError = httpError;
      }
      return _httpData;
    }else{
      if(isSetError){
        setError(_httpData.httpError);
      }
      return _httpData;
    }
  }


}